diff --git a/hw/arm/exynos4210.c b/hw/arm/exynos4210.c
index be3c96d21ea3..6be8ef4b25d1 100644
--- a/hw/arm/exynos4210.c
+++ b/hw/arm/exynos4210.c
@@ -153,7 +153,7 @@ Exynos4210State *exynos4210_init(MemoryRegion *system_mem,
     assert(cpu_oc);
 
     for (n = 0; n < EXYNOS4210_NCPUS; n++) {
-        Object *cpuobj = object_new(object_class_get_name(cpu_oc));
+        Object *cpuobj = object_new_with_class(cpu_oc);
 
         /* By default A9 CPUs have EL3 enabled.  This board does not currently
          * support EL3 so the CPU EL3 property is disabled before realization.
diff --git a/hw/arm/highbank.c b/hw/arm/highbank.c
index 80e5fd458bee..0a4eb83748d3 100644
--- a/hw/arm/highbank.c
+++ b/hw/arm/highbank.c
@@ -248,7 +248,7 @@ static void calxeda_init(MachineState *machine, enum cxmachines machine_id)
         Object *cpuobj;
         ARMCPU *cpu;
 
-        cpuobj = object_new(object_class_get_name(oc));
+        cpuobj = object_new_with_class(oc);
         cpu = ARM_CPU(cpuobj);
 
         object_property_set_int(cpuobj, QEMU_PSCI_CONDUIT_SMC,
diff --git a/hw/arm/integratorcp.c b/hw/arm/integratorcp.c
index 039812a3fd86..211abe1caae6 100644
--- a/hw/arm/integratorcp.c
+++ b/hw/arm/integratorcp.c
@@ -555,7 +555,7 @@ static void integratorcp_init(MachineState *machine)
         exit(1);
     }
 
-    cpuobj = object_new(object_class_get_name(cpu_oc));
+    cpuobj = object_new_with_class(cpu_oc);
 
     /* By default ARM1176 CPUs have EL3 enabled.  This board does not
      * currently support EL3 so the CPU EL3 property is disabled before
diff --git a/hw/arm/realview.c b/hw/arm/realview.c
index 8eafccaf1de8..e63fae0450d2 100644
--- a/hw/arm/realview.c
+++ b/hw/arm/realview.c
@@ -103,7 +103,7 @@ static void realview_init(MachineState *machine,
     }
 
     for (n = 0; n < smp_cpus; n++) {
-        Object *cpuobj = object_new(object_class_get_name(cpu_oc));
+        Object *cpuobj = object_new_with_class(cpu_oc);
 
         /* By default A9,A15 and ARM1176 CPUs have EL3 enabled.  This board
          * does not currently support EL3 so the CPU EL3 property is disabled
diff --git a/hw/arm/versatilepb.c b/hw/arm/versatilepb.c
index 8ae5392bcc16..ab54d94edb85 100644
--- a/hw/arm/versatilepb.c
+++ b/hw/arm/versatilepb.c
@@ -208,7 +208,7 @@ static void versatile_init(MachineState *machine, int board_id)
         exit(1);
     }
 
-    cpuobj = object_new(object_class_get_name(cpu_oc));
+    cpuobj = object_new_with_class(cpu_oc);
 
     /* By default ARM1176 CPUs have EL3 enabled.  This board does not
      * currently support EL3 so the CPU EL3 property is disabled before
diff --git a/hw/arm/vexpress.c b/hw/arm/vexpress.c
index 58760f40ca22..41eb6df18d77 100644
--- a/hw/arm/vexpress.c
+++ b/hw/arm/vexpress.c
@@ -215,7 +215,7 @@ static void init_cpus(const char *cpu_model, const char *privdev,
 
     /* Create the actual CPUs */
     for (n = 0; n < smp_cpus; n++) {
-        Object *cpuobj = object_new(object_class_get_name(cpu_oc));
+        Object *cpuobj = object_new_with_class(cpu_oc);
 
         if (!secure) {
             object_property_set_bool(cpuobj, false, "has_el3", NULL);
diff --git a/hw/arm/xilinx_zynq.c b/hw/arm/xilinx_zynq.c
index 7dac20d67dce..181da39ca100 100644
--- a/hw/arm/xilinx_zynq.c
+++ b/hw/arm/xilinx_zynq.c
@@ -177,7 +177,7 @@ static void zynq_init(MachineState *machine)
     }
     cpu_oc = cpu_class_by_name(TYPE_ARM_CPU, cpu_model);
 
-    cpu = ARM_CPU(object_new(object_class_get_name(cpu_oc)));
+    cpu = ARM_CPU(object_new_with_class(cpu_oc));
 
     /* By default A9 CPUs have EL3 enabled.  This board does not
      * currently support EL3 so the CPU EL3 property is disabled before
diff --git a/qom/cpu.c b/qom/cpu.c
index 484c49388d6d..9f9dc6e6a3d2 100644
--- a/qom/cpu.c
+++ b/qom/cpu.c
@@ -73,7 +73,7 @@ CPUState *cpu_generic_init(const char *typename, const char *cpu_model)
         goto out;
     }
 
-    cpu = CPU(object_new(object_class_get_name(oc)));
+    cpu = CPU(object_new_with_class(oc));
     object_property_set_bool(OBJECT(cpu), true, "realized", &err);
 
 out:
diff --git a/scripts/coccinelle/object_new_with_class.cocci b/scripts/coccinelle/object_new_with_class.cocci
new file mode 100644
index 000000000000..2b1413675322
--- /dev/null
+++ b/scripts/coccinelle/object_new_with_class.cocci
@@ -0,0 +1,5 @@
+@@
+expression x;
+@@
+- object_new(object_class_get_name(x))
++ object_new_with_class(x)
diff --git a/target-alpha/cpu.c b/target-alpha/cpu.c
index 6d01d7f75e9e..f89880451bcf 100644
--- a/target-alpha/cpu.c
+++ b/target-alpha/cpu.c
@@ -162,7 +162,7 @@ AlphaCPU *cpu_alpha_init(const char *cpu_model)
         /* Default to ev67; no reason not to emulate insns by default.  */
         cpu_class = object_class_by_name(TYPE("ev67"));
     }
-    cpu = ALPHA_CPU(object_new(object_class_get_name(cpu_class)));
+    cpu = ALPHA_CPU(object_new_with_class(cpu_class));
 
     object_property_set_bool(OBJECT(cpu), true, "realized", NULL);
 
diff --git a/target-i386/cpu.c b/target-i386/cpu.c
index 13505ab156e0..9a4c6ec190cf 100644
--- a/target-i386/cpu.c
+++ b/target-i386/cpu.c
@@ -2866,7 +2866,7 @@ static void x86_cpu_apic_create(X86CPU *cpu, Error **errp)
     APICCommonState *apic;
     ObjectClass *apic_class = OBJECT_CLASS(apic_get_class());
 
-    cpu->apic_state = DEVICE(object_new(object_class_get_name(apic_class)));
+    cpu->apic_state = DEVICE(object_new_with_class(apic_class));
 
     object_property_add_child(OBJECT(cpu), "lapic",
                               OBJECT(cpu->apic_state), &error_abort);
diff --git a/target-m68k/helper.c b/target-m68k/helper.c
index 89bbe6dfa6fc..bffbb26aba1c 100644
--- a/target-m68k/helper.c
+++ b/target-m68k/helper.c
@@ -110,7 +110,7 @@ M68kCPU *cpu_m68k_init(const char *cpu_model)
     if (oc == NULL) {
         return NULL;
     }
-    cpu = M68K_CPU(object_new(object_class_get_name(oc)));
+    cpu = M68K_CPU(object_new_with_class(oc));
     env = &cpu->env;
 
     register_m68k_insns(env);
diff --git a/target-s390x/cpu_models.c b/target-s390x/cpu_models.c
index 3ff6a702f9af..3865fdc1c9ef 100644
--- a/target-s390x/cpu_models.c
+++ b/target-s390x/cpu_models.c
@@ -334,7 +334,7 @@ static void cpu_model_from_info(S390CPUModel *model, const CpuModelInfo *info,
         error_setg(errp, "The CPU definition '%s' requires KVM", info->name);
         return;
     }
-    obj = object_new(object_class_get_name(oc));
+    obj = object_new_with_class(oc);
     cpu = S390_CPU(obj);
 
     if (!cpu->model) {
diff --git a/target-xtensa/helper.c b/target-xtensa/helper.c
index 768b32c41724..7672a13521ea 100644
--- a/target-xtensa/helper.c
+++ b/target-xtensa/helper.c
@@ -124,7 +124,7 @@ XtensaCPU *cpu_xtensa_init(const char *cpu_model)
         return NULL;
     }
 
-    cpu = XTENSA_CPU(object_new(object_class_get_name(oc)));
+    cpu = XTENSA_CPU(object_new_with_class(oc));
     env = &cpu->env;
 
     xtensa_irq_init(env);
diff --git a/vl.c b/vl.c
index f3abd99eb2f9..df15bd5bf883 100644
--- a/vl.c
+++ b/vl.c
@@ -4076,8 +4076,8 @@ int main(int argc, char **argv, char **envp)
     }
 #endif
 
-    current_machine = MACHINE(object_new(object_class_get_name(
-                          OBJECT_CLASS(machine_class))));
+    current_machine = MACHINE(
+                           object_new_with_class(OBJECT_CLASS(machine_class)));
     if (machine_help_func(qemu_get_machine_opts(), current_machine)) {
         exit(0);
     }